## Sid Meier's Civilization 4
## Copyright Firaxis Games 2005

from CvPythonExtensions import *
import sdToolKit
import CvUtil
import PyHelpers
import Popup as PyPopup

# globals
gc = CyGlobalContext()
PyPlayer = PyHelpers.PyPlayer
sd = sdToolKit

class CustomFunctions:

	def UpgradeOnTech(self, iPlayer, iTech):
		list = [["BRONZE_WORKING", "ARCHER", "CHARIOT"], ["PRIESTHOOD", "CHARIOT"],  ["IRON_WORKING", "SPEARMAN", "AXEMAN"], ["METAL_CASTING", "SPEARMAN", "AXEMAN", "SWORDSMAN"], ["CONSTRUCTION", "CATAPULT","ARCHER"], ["MATHEMATICS", "ARCHER"], ["MONARCHY", "HORSE_ARCHER"], ["CURRENCY", "HORSE_ARCHER"], ["MACHINERY", "CATAPULT", "WAR_ELEPHANT"], ["GUILDS", "TREBUCHET", "MACEMAN"], ["OPTICS", "LONGBOWMAN"], ["ENGINEERING", "CROSSBOWMAN", "WAR_ELEPHANT"], ["MUSIC", "KNIGHT"], ["EDUCATION", "TREBUCHET", "KNIGHT"], ["PRINTING_PRESS", "LONGBOWMAN", "CROSSBOWMAN"], ["NATIONALISM", "MACEMAN", "PIKEMAN"], ["CONSTITUTION", "PIKEMAN"], ["LIBERALISM", "MUSKETMAN"], ["REPLACEABLE_PARTS", "GRENADIER"], ["RIFLING", "CAVALRY"], ["STEEL", "CANNON", "GRENADIER"], ["RAILROAD", "CAVALRY"], ["SCIENTIFIC_METHOD", "RIFLEMAN"], ["FASCISM", "CAVALRY"], ["PHYSICS", "RIFLEMAN"],["ASSEMBLY_LINE", "MACHINE_GUNNER"], ["INDUSTRIALISM", "INFANTRY"], ["RADIO", "ARTILERY", "TANK"], ["ROCKETRY", "INFANTRY"], ["MASS_MEDIA", "MARINE"], ["COMPOSITES", "ARTILERY"], ["COMPUTERS", "MARINE"], ["ROBOTICS", "SAM_INFANTRY"], ["FIBER_OPTICS", "GUNSHIP"]]                                                                              

		for Tech in list:
			#sd.sdEcho("The tech being checked for is %s" % Tech[0])
			if iTech == gc.getInfoTypeForString("TECH_"+Tech[0]):
				#d.sdEcho("It has just been discovered")
				iNumUnits = gc.getPlayer(iPlayer).getNumUnits()
				for UnitClass in Tech[1:]:
					#sd.sdEcho("Checking for units of class %s" % UnitClass)
					for iUnit in range(iNumUnits):
						pUnit = gc.getPlayer(iPlayer).getUnit(iUnit)
						if pUnit.getUnitClassType() == gc.getInfoTypeForString("UNITCLASS_"+UnitClass):
							#sd.sdEcho("Unit %i has just been promoted" % iUnit)
							pUnit.setHasPromotion(gc.getInfoTypeForString("PROMOTION_"+Tech[0]+"_"+UnitClass), True)
	
	def UpgradeOnCreated(self, pUnit, pPlayer):
		#sd.sdEcho("A unit has been created")
		pTeam = pPlayer.getTeam()
		list = [["BRONZE_WORKING", "ARCHER", "CHARIOT"], ["PRIESTHOOD", "CHARIOT"],  ["IRON_WORKING", "SPEARMAN", "AXEMAN"], ["METAL_CASTING", "SPEARMAN", "AXEMAN", "SWORDSMAN"], ["CONSTRUCTION", "CATAPULT","ARCHER"], ["MATHEMATICS", "ARCHER"], ["MONARCHY", "HORSE_ARCHER"], ["CURRENCY", "HORSE_ARCHER"], ["MACHINERY", "CATAPULT", "WAR_ELEPHANT"], ["GUILDS", "TREBUCHET", "MACEMAN"], ["OPTICS", "LONGBOWMAN"], ["ENGINEERING", "CROSSBOWMAN", "WAR_ELEPHANT"], ["MUSIC", "KNIGHT"], ["EDUCATION", "TREBUCHET", "KNIGHT"], ["PRINTING_PRESS", "LONGBOWMAN", "CROSSBOWMAN"], ["NATIONALISM", "MACEMAN", "PIKEMAN"], ["CONSTITUTION", "PIKEMAN"], ["LIBERALISM", "MUSKETMAN"], ["REPLACEABLE_PARTS", "GRENADIER"], ["RIFLING", "CAVALRY"], ["STEEL", "CANNON", "GRENADIER"], ["RAILROAD", "CAVALRY"], ["SCIENTIFIC_METHOD", "RIFLEMAN"], ["FASCISM", "CAVALRY"], ["PHYSICS", "RIFLEMAN"],["ASSEMBLY_LINE", "MACHINE_GUNNER"], ["INDUSTRIALISM", "INFANTRY"], ["RADIO", "ARTILERY", "TANK"], ["ROCKETRY", "INFANTRY"], ["MASS_MEDIA", "MARINE"], ["COMPOSITES", "ARTILERY"], ["COMPUTERS", "MARINE"], ["ROBOTICS", "SAM_INFANTRY"], ["FIBER_OPTICS", "GUNSHIP"]]

		for Tech in list:
			#sd.sdEcho("Checking to see is team has %s" % Tech[0])
			if pTeam.isHasTech(gc.getInfoTypeForString("TECH_"+Tech[0])):
				for UnitClass in Tech[1:]:
					#sd.sdEcho("Checking if unit is of type %s" % UnitClass)
					if pUnit.getUnitClassType() == gc.getInfoTypeForString("UNITCLASS_"+UnitClass):
						pUnit.setHasPromotion(gc.getInfoTypeForString("PROMOTION_"+Tech[0]+"_"+UnitClass), True)
						#sd.sdEcho("Unit has been promoted")






